<ng-template #elementBlockTemplate1>
    <div class="block-ui-template">
        <div class="sk-double-bounce sk-primary">
            <div class="sk-child sk-double-bounce1"></div>
            <div class="sk-child sk-double-bounce2"></div>
        </div>
        <p class="text-center text-white"> {{loadingText}} </p>
    </div>
</ng-template>


<!-- <button *ngIf="!detectmob()" class="btn icon-btn btn-sm btn-default btn-round  "
    (click)="openFilterWindow()" placement="bottom" [ngbPopover]="tooltip()" triggers="mouseenter:mouseleave"
    popoverTitle="Filters Applied">
    <i class="fas fa-filter icon-primary font-icons" [style.color]="resultData['date_lim_ap']?'red':''"></i>
</button>

<button *ngIf="detectmob()" class="btn icon-btn btn-sm btn-default btn-round tooltipMobBottom"
    (click)="openFilterWindow()">
    <i class="fas fa-filter icon-primary font-icons" [style.color]="resultData['date_lim_ap']?'red':''"></i>
</button> -->


<!-- Filter Model for Web -->
<!-- <div id="filter-web" class="loader-wrapper " *blockUI="blockUIName;  template: elementBlockTemplate1">
    <div class="filter-container" *ngIf="showFilterWindow">
        <div class="filterontent">
            <div class="filter-main-header">
                <div class="row-one">
                    <div class="main-head modal-header">
                        <div class="modal-title">Select Your Filter Type</div>
                        <div class="text-right close-btn">
                            <i class="ion ion-md-close" aria-hidden="true" (click)="cancelClick()"></i>
                        </div>
                    </div>
                </div>
                <div *ngIf="viewFilterdata.length > 0 && !deviceService.isMobile()" class="px-3 py-2"
                    style="width:100%;">
                    <label class="form-label label-material">Selected Filters</label>
                    
                        <button class="btn btn-xs btn-outline-info borderless  ion-theme-bg label-tooltip-btn"
                            placement="top" 
                            ngbTooltip="Selected Filter that will be applied to the result">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                        </button>
                        <div class="w-100">
                        <div *ngFor="let filteritems of filterOptions;let i=index" class="d-inline-flex">
                            <div ngbDropdown [placement]="isRTL ? 'bottom-right' : 'bottom-left'"
                                class="d-inline-flex mr-1 mb-1 values-align"
                                *ngIf="filteritems.dirtyFlag && (filteritems.selectedValues.length>0 || filteritems.datefield)">
                                <button class="btn btn-primary btn-sm btn-round"  [ngClass]="currentSelectedItem==i?onChangeOnFilterItems:''"
                                    ngbDropdownToggle>{{filteritems.object_display}}</button>
                                <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL" *ngIf="filteritems.datefield">
                                    <a class="dropdown-item disabled"
                                        href="javascript:void(0)">{{dateFormat({'value':filteritems.object_name})}}</a>
                                </div>
                                <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL" *ngIf="!filteritems.datefield"
                                    style="max-height: 400px;overflow:auto;">
                                    <a class="dropdown-item disabled" href="javascript:void(0)"
                                        *ngFor="let val of filteritems.selectedValues">{{val}}</a>
                                </div>
                            </div>
                        </div>
                        </div>
                </div>
            </div>

            <div class="app-filter-content">
                <div class="row-two filter-header" *ngIf="!deviceService.isMobile()">
                    <div class="col-title px-3 py-2">
                        <label class="form-label label-material">Filter Options</label>
                        <button class="btn btn-xs btn-outline-info borderless  ion-theme-bg label-tooltip-btn"
                            placement="top"
                            ngbTooltip="Search filter options to select">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                        </button>
                        <div class="input-group">
                            <input class="form-control form-material" placeholder="Search for..." type="text"
                                [(ngModel)]="searchText_filterObj" (keyup)="onSearchInput($event, 'filterObj')">
                            <span class="form-btn" *ngIf="searchText_filterObj != ''"
                                (click)="clearSearchText('filterObj')"><i class="fa fa-times"
                                    aria-hidden="true"></i></span>
                        </div>
                    </div>

                    <div class="col-title px-3 py-2" style="border-left:1px solid #e7e7e7">
                        <label class="form-label label-material">Filter Values</label>
                        <button class="btn btn-xs btn-outline-info borderless  ion-theme-bg label-tooltip-btn"
                            placement="top"
                            ngbTooltip="Search filter type to select values">
                            <i class="ion ion-ios-information-circle-outline ion-theme"></i>
                        </button>
                        <div class="input-group">
                            <input class="form-control form-material" placeholder="Search for..." type="text"
                                [(ngModel)]="searchText_filterVal" (keyup)="onSearchInput($event, 'filterVal')">
                            <span class="form-btn" *ngIf="searchText_filterVal != ''"
                                (click)="clearSearchText('filterVal')"><i class="fa fa-times"
                                    aria-hidden="true"></i></span>
                        </div>

                        <div *ngIf="!isdateField" class="select_all float-right ml-2" style="padding-top: 7px;">
                            <label class="custom-control custom-checkbox m-0">
                                <input type="checkbox" class="custom-control-input" name="Select/UnSelect All"
                                    [(ngModel)]="isSelectAll" [checked]="isSelectAll" (change)="selectAll()">
                                <span class="custom-control-label checkbox-label">Select All</span>
                            </label>
                        </div>
                        <div class="float-right mt-2 mr-2 text-dark" style="padding-top: 4px;" placement="top"
                        ngbTooltip="Reset filter values"><i
                                class="fas fa-sync-alt" (click)="resetClick()"></i></div>
                    </div>
                </div>
                <div class="row-three">
                    <div class="filter-list">
                        <ul class="list-group">
                            <li class="list-group-item" *ngFor="let option of filterOptions_copy; let i=index;"
                                [ngClass]="{'active':selectedItem == option}" (click)="itemSelected(option,i)">
                                <div class="filter-left-item">{{option.object_display}}</div>
                                <span class="badge float-right">{{option.badge}}</span>
                            </li>
                        </ul>
                    </div>

                    <div class="filter-list filter-overflow-hidden" *ngIf="!selectedItem_copy.datefield"
                        appInfinitescroll (scrolled)="updateScrollPos($event)">
                        <ul class="list-group">
                            <li class="list-group-item" *ngFor="let value of selectedItem_copy.values"
                                (click)="multiValueChanged(selectedItem_copy, value)">
                                <span *ngIf="!selectedItem_copy.datefield && value">{{value.value}}</span>

                                <span *ngIf="!selectedItem_copy.datefield" class="float-right icon-material">
                                    <i [ngClass]="{'fas fa-check':value.selected}" aria-hidden="true"></i>
                                </span>
                            </li>
                            <li class="list-group-item"
                                *ngIf="selectedItem_copy.values && !selectedItem_copy.values.length>0">
                                No data to select
                            </li>
                            <li class="list-group-item" *ngIf="!selectedItem_copy.values">
                                <span class="text-danger" *ngIf="!value">{{isFilterFetchFail}}</span>
                            </li>
                        </ul>
                    </div>
                    <div class="filter-list" *ngIf="selectedItem_copy.datefield">
                        <ul class="list-group">
                            <li class="list-group-item" *ngFor="let value of selectedItem_copy.values"
                                (click)="multiValueChanged(selectedItem_copy, value)">
                                <div class="input-group-sm" *ngIf="selectedItem_copy.datefield">

                                    <input class="form-control" type="date"
                                        [value]="selectedItem_copy.values[0].dateValue | date:'yyyy-MM-dd'"
                                        data-date-format="yyyy-MM-dd"
                                        (input)="selectedItem_copy.values[0].dateValue = dateValueChanged(selectedItem_copy,$event.target.value)" />

                                </div>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
            <div class="app-filter-btn modal-footer">
                <button type="button" class="btn btn-default device-btn" (click)="cancelClick()">Cancel</button>
                <button type="button" class="btn btn-default device-btn" (click)="resetAllClick()">Reset All</button>
                <button type="button" class="btn btn-primary device-btn" (click)="applyClick()">Apply</button>
            </div>
        </div>
    </div>
</div> -->
<!-- Filter Model for Web -->



<!-- Filter Model for Mobile (Tab menu) -->
<div class="loader-wrapper" *blockUI="blockUIName;  template: elementBlockTemplate1">
    <div class="filter-container-1">

        <div class="filterontent-1" style="top: 0; height: 100%; padding: 0 !important;">
            <!-- <div class="filter-main-header">
                <div class="row-one">
                    <div class="main-head modal-header">


                        <div class="text-dark mt-2">
                            <i class="fas fa-sync-alt" (click)="resetClick()"></i>
                        </div>

                        <div *ngIf="!isdateField" class="select_all">
                            <label class="custom-control custom-checkbox m-0">
                                <input type="checkbox" class="custom-control-input" name="Select/UnSelect All"
                                    [(ngModel)]="isSelectAll" [checked]="isSelectAll" (change)="selectAll()">
                                <span class="custom-control-label checkbox-label">Select All</span>
                            </label>
                        </div>



                    </div>
                </div>

            </div> -->


            <div class="app-filter-content">
                <div class="row-three">
                    <ngb-tabset class="nav-tabs-top w-100" #t="ngbTabset">

                        <ngb-tab class="form-label label-material" title="Filter Options" id="tab-filter-options">
                            <ng-template ngbTabContent style="border: none !important;">

                                <div class="card-body pl-0 pr-0 pt-2">


                                    <div class="input-group mb-3 px-3">
                                        <input class="form-control form-material" style="height: 35px;"
                                            placeholder="Filter Options" type="text" [(ngModel)]="searchText_filterObj"
                                            (keyup)="onSearchInput($event, 'filterObj')">
                                        <span class="form-btn" *ngIf="searchText_filterObj != ''"
                                            (click)="clearSearchText('filterObj')">
                                            <i class="fa fa-times" aria-hidden="true"></i>
                                        </span>
                                    </div>


                                    <div *ngIf="viewFilterdata.length > 0" class="px-3 py-2 tab-menu-style "
                                        style="width:100%;">


                                        <div *ngFor="let filteritems of filterOptions" class="d-inline-block">
                                            <div ngbDropdown [placement]="isRTL ? 'bottom-right' : 'bottom-left'"
                                                class="d-inline-flex mr-1 mb-1 values-align"
                                                *ngIf="filteritems.dirtyFlag && (filteritems.selectedValues.length>0 || filteritems.datefield)">
                                                <button class="btn btn-primary btn-sm btn-round"
                                                    ngbDropdownToggle>{{filteritems.object_display}}</button>
                                                <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL"
                                                    *ngIf="filteritems.datefield">
                                                    <a class="dropdown-item"
                                                        href="javascript:void(0)">{{dateFormat({'value':filteritems.object_name})}}</a>
                                                </div>
                                                <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL"
                                                    *ngIf="!filteritems.datefield"
                                                    style="max-height: 400px;overflow:auto;">
                                                    <a class="dropdown-item" href="javascript:void(0)"
                                                        *ngFor="let val of filteritems.selectedValues">{{val}}</a>
                                                </div>
                                            </div>
                                        </div>


                                    </div>

                                    <div class="filter-list col-md-12 w-100 p-0" style="border-left: 0; height:30vh">
                                        <ul class="list-group m-0 p-0" style="border: none !important;">
                                            <li class="list-group-item px-3 py-2" style="border-radius: 0 !important;"
                                                *ngFor="let option of filterOptions_copy"
                                                [ngClass]="{'active':selectedItem == option}"
                                                (click)="itemSelected(option);t.select('tab-filter-values')">
                                                <div class="filter-left-item">{{option.object_display}}</div>
                                                <span class="badge float-right">{{option.badge}}</span>
                                            </li>
                                        </ul>
                                    </div>

                                </div>
                            </ng-template>
                        </ngb-tab>

                        <ngb-tab class="form-label label-material" title="Filter Values" id="tab-filter-values">
                            <ng-template ngbTabContent>
                                <div class="card-body pl-0 pr-0 pt-2">

                                    <div class="input-group mb-3 px-3">
                                        <input class="form-control form-material" style="height: 35px;"
                                            placeholder="Filter Values" type="text" [(ngModel)]="searchText_filterVal"
                                            (keyup)="onSearchInput($event, 'filterVal')">
                                        <span class="form-btn" *ngIf="searchText_filterVal != ''"
                                            (click)="clearSearchText('filterVal')"><i class="fa fa-times"
                                                aria-hidden="true"></i>
                                        </span>
                                    </div>


                                    <div *ngIf="viewFilterdata.length > 0" class="px-3 py-2 tab-menu-style"
                                        style="width:100%;">


                                        <div *ngFor="let filteritems of filterOptions" class="d-inline-flex">
                                            <div ngbDropdown [placement]="isRTL ? 'bottom-right' : 'bottom-left'"
                                                class="d-inline-flex mr-1 mb-1 values-align"
                                                *ngIf="filteritems.dirtyFlag && (filteritems.selectedValues.length>0 || filteritems.datefield)">
                                                <button class="btn btn-primary btn-sm btn-round"
                                                    ngbDropdownToggle>{{filteritems.object_display}}</button>
                                                <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL"
                                                    *ngIf="filteritems.datefield">
                                                    <a class="dropdown-item"
                                                        href="javascript:void(0)">{{dateFormat({'value':filteritems.object_name})}}</a>
                                                </div>
                                                <div ngbDropdownMenu [class.dropdown-menu-right]="isRTL"
                                                    *ngIf="!filteritems.datefield"
                                                    style="max-height: 400px;overflow:auto;">
                                                    <a class="dropdown-item" href="javascript:void(0)"
                                                        *ngFor="let val of filteritems.selectedValues">{{val}}</a>
                                                </div>
                                            </div>
                                        </div>


                                    </div>

                                    <div class="filter-list filter-overflow-hidden col-md-12 w-100 p-0"
                                        *ngIf="!selectedItem_copy.datefield" appInfinitescroll
                                        (scrolled)="updateScrollPos($event)" style="border-left: 0; height:30vh">
                                        <ul class="list-group m-0 p-0" style="border: none !important;">
                                            <li class="list-group-item px-3 py-2" style="border-radius: 0 !important;"
                                                *ngFor="let value of selectedItem_copy.values"
                                                (click)="multiValueChanged(selectedItem_copy, value)">
                                                <span
                                                    *ngIf="!selectedItem_copy.datefield && value">{{value.value}}</span>

                                                <span *ngIf="!selectedItem_copy.datefield"
                                                    class="float-right icon-material">
                                                    <i [ngClass]="{'fas fa-check':value.selected}"
                                                        aria-hidden="true"></i>
                                                </span>
                                            </li>
                                            <li class="list-group-item px-3 py-2" style="border-radius: 0 !important;"
                                                *ngIf="selectedItem_copy.values && !selectedItem_copy.values.length>0">
                                                No data to select
                                            </li>
                                            <li class="list-group-item px-3 py-2" style="border-radius: 0 !important;"
                                                *ngIf="!selectedItem_copy.values">
                                                <span class="text-danger" *ngIf="!value">{{isFilterFetchFail}}</span>
                                            </li>
                                        </ul>
                                    </div>
                                    <div class="filter-list col-md-12 w-100 p-0" *ngIf="selectedItem_copy.datefield"
                                        style="border-left: 0;height:30vh">
                                        <ul class="list-group m-0 p-0" style="border: none !important;">
                                            <li class="list-group-item px-3 py-2" style="border-radius: 0 !important;"
                                                *ngFor="let value of selectedItem_copy.values"
                                                (click)="multiValueChanged(selectedItem_copy, value)">
                                                <div class="input-group-sm" *ngIf="selectedItem_copy.datefield">

                                                    <input class="form-control" type="date"
                                                        [value]="selectedItem_copy.values[0].dateValue | date:'yyyy-MM-dd'"
                                                        data-date-format="yyyy-MM-dd"
                                                        (input)="selectedItem_copy.values[0].dateValue = dateValueChanged(selectedItem_copy,$event.target.value)" />

                                                </div>
                                            </li>
                                        </ul>
                                    </div>
                                </div>
                            </ng-template>
                        </ngb-tab>

                    </ngb-tabset>
                </div>
            </div>

            <div class="app-filter-btn modal-footer">
                <button type="button" class="btn btn-default btn-sm device-btn" (click)="cancelClick()">Cancel</button>
                <button type="button" class="btn btn-default btn-sm device-btn" (click)="resetAllClick()">Reset All</button>
                <button type="button" class="btn btn-primary btn-sm device-btn" (click)="applyClick()">Apply</button>
            </div>
        </div>

    </div>
</div>
<!-- Filter Model for Mobile (Tab menu) -->